#!/bin/bash -e

# Copying and distribution of this file, with or without modification,
# are permitted in any medium without royalty provided the copyright
# notice and this notice are preserved.  This file is offered as-is,
# without any warranty.

DC=$1           # dmd, ldc2 or gdc

SRCDIR=source

set -x

if [[ ${DC} == dmd ]]; then
    OUT="-of"
elif [[ ${DC} == ldc2 ]]; then
    OUT="-of"
elif [[ ${DC} == gdc ]]; then
    OUT="-o "
fi

pushd res
${DC} converter.d ${OUT}converter
./converter fileformats.csv  # creates fileformats.dtxt
rm -f converter converter.o
popd

line=`grep -n "private static const FileFormat" ${SRCDIR}/fileformats.d`
LINE_NUMBER=${line%:*}
head -n $LINE_NUMBER ${SRCDIR}/fileformats.d > ${SRCDIR}/formats_temp
cat ${SRCDIR}/formats_temp res/fileformats.dtxt > ${SRCDIR}/fileformats.d
rm res/fileformats.dtxt ${SRCDIR}/formats_temp

set +x
